                                               'DLINE_AXIAL

DIM X1(80), X2(80)
SCREEN 2
C$ = "  +#.#####^^^^"
Pi = 3.141593
Mo = 4 * Pi * .0000001
M = 1.67E-27 * 2
Q = 1.6E-19
E = 300        '[eV]
REM J = 4E+11
LOCATE 1, 1
INPUT "ANGLE (5 - 175 STEP 5)="; AN     'optimal = 132.5
TV = AN * Pi / 180
        V = SQR(2 * E * ABS(Q) / M)
        Vx = V * COS(TV)
        Vy = V * SIN(TV)
        Vz = 0
        LOCATE 1, 60
        PRINT "V ="; USING C$; V
dlq = .0001
'dt = dlq / V
A = .05
YL1 = 0
YL2 = 0
Xv = 0
Yv = 0
Zv = 0
L = .08
DL = .001
N = L / DL
REM Du = .01
REM S = Pi * Du ^ 2 / 4
REM IL = S * J
IL = 2000000
K = Mo / (4 * Pi)
        FOR i = 0 TO N - 1
        X1(i) = -i * DL - DL / 2 - A
        X2(i) = i * DL + DL / 2 + A
        PSET ((X1(i) * 4000 + 320), 4000 * YL1 + 100)
        PSET ((X2(i) * 4000 + 320), 4000 * YL2 + 100)
        NEXT i
FOR t = 0 TO 100000
REM LOCATE 2, 73
REM PRINT t
dt = dlq / V
        PXx = 0
        PXy = 0
        PXz = 0
        FOR i = 0 TO N - 1
        Rx1 = Xv - X1(i)
        Rx2 = Xv - X2(i)
                Ux = DL
                Uy = 0
                Uz = 0
                Ry1 = Yv + YL1
                Ry2 = Yv + YL2
                Rz = Zv
                 R1 = SQR(Rx1 * Rx1 + Ry1 * Ry1 + Rz * Rz)
                 R2 = SQR(Rx2 * Rx2 + Ry2 * Ry2 + Rz * Rz)

                REM Hx1 =  (Uy * Rz - Ry1 * Uz) / R1 ^ 3
                REM Hy1 =  (Uz * Rx1 - Rz * Ux) / R1 ^ 3
                REM Hz1 =  (Ux * Ry1 - Rx1 * Uy) / R1 ^ 3
               
                Hy1 = (-Rz * Ux) / R1 ^ 3
                Hz1 = (Ux * Ry1) / R1 ^ 3

                 Hy2 = (-Rz * Ux) / R2 ^ 3
                 Hz2 = (Ux * Ry2) / R2 ^ 3

                REM Px =  (Vy * (Hz1 + Hz2) - (Hy1 + Hy2) * Vz)
                REM Py =  (Vz * (Hx1 + Hx2) - (Hz1 + Hz2) * Vx)
                REM Pz =  (Vx * (Hy1 + Hy2) - (Hx1 + Hx2) * Vy)
               
                Px = (Vy * (Hz1 + Hz2) - (Hy1 + Hy2) * Vz)
                Py = -(Hz1 + Hz2) * Vx
                Pz = Vx * (Hy1 + Hy2)

                 PXx = PXx + Px
                 PXy = PXy + Py
                 PXz = PXz + Pz
            NEXT i
        dVx = Q * K * IL * PXx * dt / M
        dVy = Q * K * IL * PXy * dt / M
        dVz = Q * K * IL * PXz * dt / M
          Vxt = Vx + dVx
          Vyt = Vy + dVy
          Vzt = Vz + dVz
          Vt = SQR(Vxt ^ 2 + Vyt ^ 2 + Vzt ^ 2)
          kV = V / Vt
'kV - ࠢ 樥, ⮬,  ᪮   ⭮
'   
        Vx = Vxt * kV
        Vy = Vyt * kV
        Vz = Vzt * kV
        V = SQR(Vx ^ 2 + Vy ^ 2 + Vz ^ 2)
          REM LOCATE 4, 60
          REM PRINT "V'="; USING C$; V
        dXv = Vx * dt
        dYv = Vy * dt
        dZv = Vz * dt
          Xv = Xv + dXv
          Yv = Yv + dYv
          Zv = Zv + dZv
     PSET (Xv * 7000 + 320, Yv * 4000 + 100)
        REM LOCATE 1, 1
        REM PRINT "PX = "; USING C$; PXx; PXy; PXz
        REM LOCATE 2, 1
        REM PRINT "dV = "; USING C$; dVx; dVy; dVz
        NEXT t

