DIM XP1(300), XP2(300)
SCREEN 1
C$ = " ##.##^^^^"
Pi = 3.141593
Eo = 8.85E-12
Mo = 4 * Pi * .0000001
M = 1.67E-27
Me = 9.1E-31
Q = 1.6E-19
E = 10000!      '[eV]
J = 7E+11
LOCATE 1, 1
INPUT "ANGLE (0-180)="; AN
TV = AN * Pi / 180
        V = SQR(2 * E * ABS(Q) / M)     ' (m/s)
        Vx1 = V * COS(TV)
        Vy1 = V * SIN(TV)
        Vz1 = 0
         Vx2 = Vx1
         Vy2 = -Vy1
dlq = .0000001
A = .000005
Xv1 = 0
Yv1 = .00003
 Xv2 = 0
 Yv2 = -.00003
L = .01
DL = .001
N = L / DL
Du = .002
s = Pi * Du ^ 2 / 4
IL = s * J
K = Mo / (4 * Pi)
        FOR i = 0 TO N - 1
        XP1(i) = -i * DL - DL / 2 - A
        XP2(i) = i * DL + DL / 2 + A
        REM PSET ((XP1(i) * 3000 + 160), 100)
        REM PSET ((XP2(i) * 3000 + 160), 100)
        NEXT i
tt = 0
FOR t = 0 TO 20000000
IL = s * J
dt = dlq / V
tt = tt + dt
LOCATE 1, 28
PRINT "t ="; USING C$; tt
        PXx1 = 0
        PXy1 = 0
        PXx2 = 0
        PXy2 = 0
        PCx1 = 0
        PCy1 = 0
        PCx2 = 0
        PCy2 = 0
HHH = 0
        FOR i = 0 TO N - 1
        Rx11 = Xv1 - XP1(i)
        Rx12 = Xv1 - XP2(i)
         Rx21 = Xv2 - XP1(i)
         Rx22 = Xv2 - XP2(i)
                Ux = DL
                REM  Uy = 0 Uz = 0
                Ry1 = Yv1
                Ry2 = Yv2
                
                 R11 = SQR(Rx11 * Rx11 + Ry1 * Ry1)
                 R12 = SQR(Rx12 * Rx12 + Ry1 * Ry1)
                  R21 = SQR(Rx21 * Rx21 + Ry2 * Ry2)
                  R22 = SQR(Rx22 * Rx22 + Ry2 * Ry2)
                    RGx1 = Xv1 - Xv2
                    RGy1 = Yv1 - Yv2
                    RG1 = SQR(RGx1 ^ 2 + RGy1 ^ 2)
                    RGx2 = -RGx1
                    RGy2 = -RGy1
                    RG2 = RG1
               
                REM Hx1 =  (Uy * Rz - Ry * Uz) / R1 ^ 3
                REM Hy1 =  (Uz * Rx1 - Rz * Ux) / R1 ^ 3
                REM Hz1 =  (Ux * Ry - Rx1 * Uy) / R1 ^ 3
               
                Hz11 = (Ux * Ry1) / R11 ^ 3
                Hz12 = (Ux * Ry1) / R12 ^ 3
                 Hz21 = (Ux * Ry2) / R21 ^ 3
                 Hz22 = (Ux * Ry2) / R22 ^ 3

REM HH1 = SQR(Hz11 ^ 2 + Hz12 ^ 2)
REM HHH = HHH + HH1

                 REM Px = (Vy * (Hz1 + Hz2) - (Hy1 + Hy2) * Vz)
                 REM Py = (Vz * (Hx1 + Hx2) - (Hz1 + Hz2) * Vx)
                 REM Pz = (Vx * (Hy1 + Hy2) - (Hx1 + Hx2) * Vy)
                 
        PGx1 = RGx1 / (ABS(RG1 ^ 3))
        PGy1 = RGy1 / (ABS(RG1 ^ 3))
        PGx2 = RGx2 / (ABS(RG2 ^ 3))
        PGy2 = RGy2 / (ABS(RG2 ^ 3))

                Px1 = Vy1 * (Hz11 + Hz12)
                Py1 = -(Hz11 + Hz12) * Vx1
                 Px2 = Vy2 * (Hz21 + Hz22)
                 Py2 = -(Hz21 + Hz22) * Vx2
                
                PCx1 = PCx1 + PGx1
                PCy1 = PCy1 + PGy1
                 PCx2 = PCx2 + PGx2
                 PCy2 = PCy2 + PGy2
               
                 PXx1 = PXx1 + Px1
                 PXy1 = PXy1 + Py1
                  PXx2 = PXx2 + Px2
                  PXy2 = PXy2 + Py2
           
            NEXT i

REM RLm = M * Vt / (Q * HHH * Mo)
REM LOCATE 3, 1
REM PRINT "M="; USING C$; M
REM LOCATE 4, 1
REM PRINT "Vt="; USING C$; Vt
REM LOCATE 5, 1
REM PRINT "HHH="; USING C$; HHH
REM LOCATE 6, 1
REM PRINT "Q="; USING C$; Q
REM LOCATE 7, 1
REM PRINT "Mo="; USING C$; Mo
REM LOCATE 8, 1
REM PRINT "RLarmor="; USING C$; RLm
       
        dVx1 = Q * K * IL * PXx1 * dt / M
        dVy1 = Q * K * IL * PXy1 * dt / M
         dVx2 = Q * K * IL * PXx2 * dt / M
         dVy2 = Q * K * IL * PXy2 * dt / M
        
          Vxt1 = Vx1 + dVx1
          Vyt1 = Vy1 + dVy1
          Vt1 = SQR(Vxt1 ^ 2 + Vyt1 ^ 2)
          kV1 = V / Vt1
         
           Vxt2 = Vx2 + dVx2
           Vyt2 = Vy2 + dVy2
           Vt2 = SQR(Vxt2 ^ 2 + Vyt2 ^ 2)
           kV2 = V / Vt2
'kV - ࠢ 樥, ⮬,  ᪮   ⭮
'     
        dVCx1 = Q ^ 2 * PCx1 * dt / M / (4 * Pi * Eo)
        dVCy1 = Q ^ 2 * PCy1 * dt / M / (4 * Pi * Eo)
        dVCx2 = Q ^ 2 * PCx2 * dt / M / (4 * Pi * Eo)
         dVCy2 = Q ^ 2 * PCy2 * dt / M / (4 * Pi * Eo)
        
        Vx1 = Vxt1 * kV1 + dVCx1
        Vy1 = Vyt1 * kV1 + dVCy1
         Vx2 = Vxt2 * kV2 + dVCx2
         Vy2 = Vyt2 * kV2 + dVCy2
        Vt = SQR(Vx1 ^ 2 + Vy1 ^ 2 + Vz1 ^ 2)
             
          REM LOCATE 23, 20
          REM PRINT "Vt ="; USING C$; Vt
       
        dXv1 = Vx1 * dt
        dYv1 = Vy1 * dt
         dXv2 = Vx2 * dt
         dYv2 = Vy2 * dt
    
          Xv1 = Xv1 + dXv1
          Yv1 = Yv1 + dYv1
           Xv2 = Xv2 + dXv2
           Yv2 = Yv2 + dYv2
          
     PSET (Xv1 * 300000 + 160, Yv1 * 300000 + 100), 1
     PSET (Xv2 * 300000 + 160, Yv2 * 300000 + 100), 2
    
Y12 = Yv1 - Yv2
IF Y12 < .0000000000001# THEN dlq = .000000000000005#
IF Y12 > .0000000000001# THEN dlq = .00000000000001#
IF Y12 > .000000000001# THEN dlq = .0000000000001#
IF Y12 > 9.999999999999999D-12 THEN dlq = .000000000001#
IF Y12 > .0000000001# THEN dlq = 9.999999999999999D-12
IF Y12 > .000000001# THEN dlq = .0000000001#
IF Y12 > .00000001# THEN dlq = .000000001#
IF Y12 > .0000001# THEN dlq = .00000001#
IF Y12 > .000001 THEN dlq = .0000001#
IF Y12 > .00001 THEN dlq = .000001#
REM IF Y12 > .0001 THEN dlq = .00001#
REM IF Y12 > .001 THEN dlq = .0001#

     IF t = 2000 THEN CLS 1
     IF t = 5000 THEN CLS 1
     IF t = 10000 THEN CLS 1
     IF t = 15000 THEN CLS 1
     IF t = 20000 THEN CLS 1
     IF t = 25000 THEN CLS 1
     IF t = 30000 THEN CLS 1
     IF t = 35000 THEN CLS 1
     IF t = 40000 THEN CLS 1
REM     IF t = 45000 THEN CLS 1
     IF t = 50000 THEN CLS 1
REM     IF t = 55000 THEN CLS 1
     IF t = 60000 THEN CLS 1
REM     IF t = 65000 THEN CLS 1
     IF t = 70000 THEN CLS 1
REM     IF t = 75000 THEN CLS 1
     IF t = 80000 THEN CLS 1
REM     IF t = 85000 THEN CLS 1
     IF t = 90000 THEN CLS 1
REM     IF t = 95000 THEN CLS 1
     IF t = 100000 THEN CLS 1
     IF t = 150000 THEN CLS 1
     IF t = 200000 THEN CLS 1
     IF t = 250000 THEN CLS 1
     IF t = 300000 THEN CLS 1
     IF t = 350000 THEN CLS 1
     IF t = 400000 THEN CLS 1
     IF t = 450000 THEN CLS 1
     IF t = 500000 THEN CLS 1
     IF t = 600000 THEN CLS 1
     IF t = 700000 THEN CLS 1
     IF t = 1000000 THEN CLS 1
     NEXT t
        END

