DIM SG(360), CG(360), f(100), ly(100)
SCREEN 2
C$ = "  +#.#####^^^^"
Pi = 3.141593
Mo = 4 * Pi * .0000001
M = 9.1E-31
REM 1.67E-27*2
Q = 1.6E-19
E = 1000!      '[eV]
J = 1E+11
TV = -150 * Pi / 180
        V = SQR(2 * E * ABS(Q) / M)
        Vx = V * COS(TV)
        Vy = V * SIN(TV)
        Vz = 0
        LOCATE 3, 60
        PRINT "V ="; USING C$; V
dlq = .0002
dt = dlq / V
R = .002
h = .0003
Xv = 0
Yv = 0
Zv = 0
Iu = J * Pi * R
K = Mo / (4 * Pi)
GU = Pi / 180
        FOR i = 0 TO 359
        SG(i) = SIN(i * GU + GU / 2)
        CG(i) = COS(i * GU + GU / 2)
        NEXT i
FOR i = 1 TO 99
f(0) = 0
lx = .0001
f(i) = 1 / (i * lx) ^ 3
ly(i) = f(i) - f(i - 1)
PSET ((i * 2 + R * 40000 + 320), (f(i) / 200000000 + h * 100000 + 100))
PSET ((-i * 2 - R * 40000 + 320), (f(i) / 200000000 + h * 100000 + 100))
PSET ((i * 2 + R * 40000 + 320), (-f(i) / 200000000 - h * 100000 + 100))
PSET ((-i * 2 - R * 40000 + 320), (-f(i) / 200000000 - h * 100000 + 100))
NEXT i
REM END

FOR t = 0 TO 200
LOCATE 2, 73
PRINT t
        PGx = 0
        PGy = 0
        PGz = 0
        FOR g = 1 TO 99
        Rx = Xv - g * lx - lx / 2
        Rx2 = Rx ^ 2
           Ux = lx
                PXx = 0
                PXy = 0
                PXz = 0
                Pqx = 0
                Pqy = 0
                Pqz = 0
                FOR i = 0 TO 359
                   Uy = ly(g) * SG(i)
                   Uz = ly(g) * CG(i)
                Ry = Yv - ((f(g) + f(g - 1)) / 2) * SG(i)
                Rz = Zv - ((f(g) + f(g - 1)) / 2) * CG(i)
                R3 = SQR(Rx2 + Ry * Ry + Rz * Rz) ^ 3
                   Hx = (Uy * Rz - Ry * Uz) / R3
                   Hy = (Uz * Rx - Rz * Ux) / R3
                   Hz = (Ux * Ry - Rx * Uy) / R3
                                        'Px = Vy*Hz-Hy*Vz    PXx = PXx + Px
                                        'Py = Vz*Hx-Hz*Vx    PXy = PXy + Py
                                        'Pz = Vx*Hy-Hx*Vy    PXz = PXz + Pz
                PXx = PXx + (Vy * Hz - Hy * Vz)
                PXy = PXy + (Vz * Hx - Hz * Vx)
                PXz = PXz + (Vx * Hy - Hx * Vy)
           NEXT i
                PGx = PGx + PXx
                PGy = PGy + PXy
                PGz = PGz + PXz
                NEXT g

        dVx = K * Q * Iu * PGx * dt / M
        dVy = K * Q * Iu * PGy * dt / M
        dVz = K * Q * Iu * PGz * dt / M
          Vx = Vx + dVx
          Vy = Vy + dVy
          Vz = Vz + dVz
          V = SQR(Vx ^ 2 + Vy ^ 2 + Vz ^ 2)
          LOCATE 4, 60
          PRINT "V'="; USING C$; V
        dXv = Vx * dt
        dYv = Vy * dt
        dZv = Vz * dt
          Xv = Xv + dXv
          Yv = Yv + dYv
          Zv = Zv + dZv
          PSET (Xv * 20000 + 320, Yv * 15000 + 100)
        LOCATE 1, 1
        PRINT "PG1= "; USING C$; PGx1; PGy1; PGz1
        LOCATE 2, 1
        PRINT "PG = "; USING C$; PGx; PGy; PGz
        LOCATE 3, 1
        PRINT "dV = "; USING C$; dVx; dVy; dVz
        NEXT t
         END

