                                                  'DCIL_AXIAL
DIM X1(50), X2(50), Y(360), Z(360)
SCREEN 2
C$ = "  +#.#####^^^^"
Pi = 3.141593
Mo = 4 * Pi * .0000001
M = 1.67E-27 * 2
    Q = 1.6E-19
    E = 50000!      '[eV]
    J = 5E+11
1   LOCATE 4, 1
    INPUT "ANGLE (5 - 175 STEP 5)="; AN     'optimal = 130
    TV = AN * Pi / 180
        V = SQR(2 * E * ABS(Q) / M)
        Vx = V * COS(TV)
        Vy = V * SIN(TV)
        Vz = 0
        LOCATE 1, 60
        PRINT "V ="; USING C$; V
dlq = .002
dt = dlq / V
A = .05
Rc = .07 * A
Xv = .05 + A
Yv = 0
Zv = 0
GU = Pi / 180
DL = .001
DH = .005
DS = Rc * GU
S = DH * DS
IL = S * J
K = Mo / (4 * Pi)
        FOR i = 0 TO 49
        X1(i) = i * DL + DL / 2
        X2(i) = i * DL + DL * 50 + 2 * A + DL / 2
        PSET ((X1(i) * 2500 + 320 - 2 * A * 2500), Rc * 1000 + 100)
        PSET ((X1(i) * 2500 + 320 - 2 * A * 2500), -Rc * 1000 + 100)
        PSET ((X2(i) * 2500 + 320 - 2 * A * 2500), Rc * 1000 + 100)
        PSET ((X2(i) * 2500 + 320 - 2 * A * 2500), -Rc * 1000 + 100)
        NEXT i
                FOR i = 0 TO 359
                Y(i) = Rc * SIN(i * GU)
                Z(i) = Rc * COS(i * GU)
                NEXT i
FOR t = 0 TO 100
LOCATE 2, 73
PRINT t
        PGx = 0
        PGy = 0
        PGz = 0
        FOR g = 0 TO 49
        Ux1 = DL
        Ux2 = DL
        Rx1 = Xv - X1(g)
        Rx2 = Xv - X2(g)
                PXx = 0
                PXy = 0
                PXz = 0
                Uz = 0
                Uy = 0
                Hx1 = 0
                Hx2 = 0
                FOR i = 0 TO 359
                Ry = Yv - Y(i)
                Rz = Zv - Z(i)
              ' R = SQR(Rx*Rx+Ry*Ry+Rz*Rz)  R3= R^3
                R31 = SQR(Rx1 * Rx1 + Ry * Ry + Rz * Rz) ^ 3
                R32 = SQR(Rx2 * Rx2 + Ry * Ry + Rz * Rz) ^ 3
              ' Hx1 = (Uy * Rz - Ry * Uz) / R31  = 0
                Hy1 = K * IL * (Uz * Rx1 - Rz * Ux1) / R31
                Hz1 = K * IL * (Ux1 * Ry - Rx1 * Uy) / R31
              ' Hx2 = (Uy * Rz - Ry * Uz) / R32  = 0
                Hy2 = K * IL * (Uz * Rx2 - Rz * Ux2) / R32
                Hz2 = K * IL * (Ux2 * Ry - Rx2 * Uy) / R32
                 PXx = PXx + Q * (Vy * (Hz1 + Hz2) - (Hy1 + Hy2) * Vz)
                 PXy = PXy + Q * (Vz * (Hx1 + Hx2) - (Hz1 + Hz2) * Vx)
                 PXz = PXz + Q * (Vx * (Hy1 + Hy2) - (Hx1 + Hx2) * Vy)
                 NEXT i
                PGx = PGx + PXx
                PGy = PGy + PXy
                PGz = PGz + PXz
                NEXT g
        dVx = PGx * dt / M
        dVy = PGy * dt / M
        dVz = PGz * dt / M
          Vx = Vx + dVx
          Vy = Vy + dVy
          Vz = Vz + dVz
          V = SQR(Vx ^ 2 + Vy ^ 2 + Vz ^ 2)
          LOCATE 4, 60
          PRINT "V'="; USING C$; V
        dXv = Vx * dt
        dYv = Vy * dt
        dZv = Vz * dt
          Xv = Xv + dXv
          Yv = Yv + dYv
          Zv = Zv + dZv
          PSET (Xv * 2500 + 320 - 2 * A * 2500, Yv * 1000 + 100)
        LOCATE 1, 1
        PRINT "PG = "; USING C$; PGx; PGy; PGz;
        LOCATE 2, 1
        PRINT "dV = "; USING C$; dVx; dVy; dVz
        NEXT t
        CLS
        GOTO 1

