
SCREEN 12
TIMER ON
COLOR 3
LOCATE 3, 12
PRINT "                 Motion of two deuterones"
LOCATE 5, 12
PRINT " in a increasing magnetic field such as a Magnetic Cocoon "
LOCATE 7, 12
PRINT "                     (Spherical pinch)"
COLOR 15
ON TIMER(4) GOSUB 1
DO WHILE INKEY$ = "": LOOP

1
CLS
DIM XP1(80), XP2(80)
C$ = " ##.###^^^^"
Pi = 3.141593
Eo = 8.85E-12
Mo = 4 * Pi * .0000001
M = 1.67E-27 * 2
Q = 1.6E-19
E = 10000       '[eV]
J = 7E+10
LOCATE 2, 10
INPUT "ANGLE (60 - 300)="; AN
IF 300 < AN GOTO 1
IF AN < 60 GOTO 1
TV = AN * Pi / 180
	V = SQR(2 * E * ABS(Q) / M)
	Vx1 = V * COS(TV)
	Vy1 = V * SIN(TV)
	Vz1 = 0
	 Vx2 = Vx1
	 Vy2 = -Vy1
dlq = .0003
A = .015
Xv1 = 0
Yv1 = .001
 Xv2 = 0
 Yv2 = -.001
L = .08
DL = .001
N = L / DL
Du = .01
s = Pi * Du ^ 2 / 4
IL = s * J
K = Mo / (4 * Pi)
	FOR i = 0 TO N - 1
	XP1(i) = -i * DL - DL / 2 - A
	XP2(i) = i * DL + DL / 2 + A
	'PSET ((XP1(I) * 2000 + 320 - A * 5000), 240)
	'PSET ((XP2(I) * 2000 + 320 + A * 5000), 240)
	NEXT i
tt = 0
FOR t = 0 TO 8000
dt = dlq / V
tt = tt + dt
LOCATE 2, 65
PRINT "t ="; USING C$; tt
LOCATE 4, 65
PRINT "I ="; USING C$; IL

	PXx1 = 0
	PXy1 = 0
	PXx2 = 0
	PXy2 = 0
	PCx1 = 0
	PCy1 = 0
	PCx2 = 0
	PCy2 = 0
	FOR i = 0 TO N - 1
	Rx11 = Xv1 - XP1(i)
	Rx12 = Xv1 - XP2(i)
	 Rx21 = Xv2 - XP1(i)
	 Rx22 = Xv2 - XP2(i)
		Ux = DL
		REM  Uy = 0 Uz = 0
		Ry1 = Yv1
		Ry2 = Yv2

		 R11 = SQR(Rx11 * Rx11 + Ry1 * Ry1)
		 R12 = SQR(Rx12 * Rx12 + Ry1 * Ry1)
		  R21 = SQR(Rx21 * Rx21 + Ry2 * Ry2)
		  R22 = SQR(Rx22 * Rx22 + Ry2 * Ry2)
		    RGx1 = Xv1 - Xv2
		    RGy1 = Yv1 - Yv2
		    RG1 = SQR(RGx1 ^ 2 + RGy1 ^ 2)
		    RGx2 = -RGx1
		    RGy2 = -RGy1
		    RG2 = RG1

		REM Hx1 =  (Uy * Rz - Ry * Uz) / R1 ^ 3
		REM Hy1 =  (Uz * Rx1 - Rz * Ux) / R1 ^ 3
		REM Hz1 =  (Ux * Ry - Rx1 * Uy) / R1 ^ 3

		Hz11 = (Ux * Ry1) / R11 ^ 3
		Hz12 = (Ux * Ry1) / R12 ^ 3
		 Hz21 = (Ux * Ry2) / R21 ^ 3
		 Hz22 = (Ux * Ry2) / R22 ^ 3

		 REM Px = (Vy * (Hz1 + Hz2) - (Hy1 + Hy2) * Vz)
		 REM Py = (Vz * (Hx1 + Hx2) - (Hz1 + Hz2) * Vx)
		 REM Pz = (Vx * (Hy1 + Hy2) - (Hx1 + Hx2) * Vy)

	PGx1 = RGx1 / (ABS(RG1 ^ 3))
	PGy1 = RGy1 / (ABS(RG1 ^ 3))
	PGx2 = RGx2 / (ABS(RG2 ^ 3))
	PGy2 = RGy2 / (ABS(RG2 ^ 3))

		Px1 = Vy1 * (Hz11 + Hz12)
		Py1 = -(Hz11 + Hz12) * Vx1
		 Px2 = Vy2 * (Hz21 + Hz22)
		 Py2 = -(Hz21 + Hz22) * Vx2

		PCx1 = PCx1 + PGx1
		PCy1 = PCy1 + PGy1
		 PCx2 = PCx2 + PGx2
		 PCy2 = PCy2 + PGy2

		 PXx1 = PXx1 + Px1
		 PXy1 = PXy1 + Py1
		  PXx2 = PXx2 + Px2
		  PXy2 = PXy2 + Py2

	    NEXT i
	dVx1 = Q * K * IL * PXx1 * dt / M
	dVy1 = Q * K * IL * PXy1 * dt / M
	 dVx2 = Q * K * IL * PXx2 * dt / M
	 dVy2 = Q * K * IL * PXy2 * dt / M

	  Vxt1 = Vx1 + dVx1
	  Vyt1 = Vy1 + dVy1
	  Vt1 = SQR(Vxt1 ^ 2 + Vyt1 ^ 2)
	  kV1 = V / Vt1

	   Vxt2 = Vx2 + dVx2
	   Vyt2 = Vy2 + dVy2
	   Vt2 = SQR(Vxt2 ^ 2 + Vyt2 ^ 2)
	   kV2 = V / Vt2

'kV - the particle must have a constant value modulo of velocity       

kq = 3000       'Magnification of distance of a Coulomb interaction
		'imitates group of particles
       
	dVCx1 = (kq * Q) ^ 2 * PCx1 * dt / M / (4 * Pi * Eo)
	dVCy1 = (kq * Q) ^ 2 * PCy1 * dt / M / (4 * Pi * Eo)
	dVCx2 = (kq * Q) ^ 2 * PCx2 * dt / M / (4 * Pi * Eo)
	dVCy2 = (kq * Q) ^ 2 * PCy2 * dt / M / (4 * Pi * Eo)

	Vx1 = Vxt1 * kV1 + dVCx1
	Vy1 = Vyt1 * kV1 + dVCy1
	 Vx2 = Vxt2 * kV2 + dVCx2
	 Vy2 = Vyt2 * kV2 + dVCy2
	Vt = SQR(Vx1 ^ 2 + Vy1 ^ 2 + Vz1 ^ 2)

	  REM LOCATE 23, 20
	  REM PRINT "Vt ="; USING C$; Vt

	dXv1 = Vx1 * dt
	dYv1 = Vy1 * dt
	 dXv2 = Vx2 * dt
	 dYv2 = Vy2 * dt

	  Xv1 = Xv1 + dXv1
	  Yv1 = Yv1 + dYv1
	   Xv2 = Xv2 + dXv2
	   Yv2 = Yv2 + dYv2

     PSET (Xv1 * 25000 + 320, Yv1 * 25000 + 240), 9
     PSET (Xv2 * 25000 + 320, Yv2 * 25000 + 240), 4


Y12 = Yv1 - Yv2
IF Y12 < .0000000000002# THEN dlq = .00000000000001#
IF Y12 > .0000000000002# THEN dlq = .00000000000002#
IF Y12 > .000000000002# THEN dlq = .0000000000002#
IF Y12 > .00000000002# THEN dlq = .000000000002#
IF Y12 > .0000000002# THEN dlq = .00000000002#
IF Y12 > .000000002# THEN dlq = .0000000002#
IF Y12 > .00000002# THEN dlq = .000000002#
IF Y12 > .0000002# THEN dlq = .00000002#
IF Y12 > .000002 THEN dlq = .0000002#
IF Y12 > .00002 THEN dlq = .000004#
IF Y12 > .0002 THEN dlq = .00004#
IF Y12 > .002 THEN dlq = .0001#

     IF t = 7000 THEN CLS 1

J = J + 8E+07
IL = s * J
NEXT t

LOCATE 29, 5
INPUT "Repeat with other angle - 1  "; U1
IF U1 = 1 THEN GOTO 1
IF U1 <> 1 THEN END

