						' D2S_FIFQ_NEW
DIM SG(360), CG(360), Sx(180), Sy(180)
SCREEN 2
C$ = "  +#.#####^^^^"
Pi = 3.141593
Mo = 4 * Pi * .0000001
M = 1.67E-27 * 2
Q = 1.6E-19
E = 50000!      '[eV]
J = 2E+10
Du = .001
TV = 150 * Pi / 180
K = Mo / (4 * Pi)
Iu = J * Pi * Du ^ 2 / 4
	V = SQR(2 * E * ABS(Q) / M)
	Vx = V * COS(TV)
	Vy = V * SIN(TV)
	Vz = 0
	LOCATE 3, 60
	PRINT "V ="; USING C$; V
dlq = .0005
dt = dlq / V
A = .05
Xv = 0
Yv = 0
Zv = 0
PSET (Xv * 2500 + 320, Yv * 1000 + 100)
GU = Pi / 180
dlU = A * GU
	FOR i = 0 TO 359
	SG(i) = SIN(i * GU + GU / 2)
	CG(i) = COS(i * GU + GU / 2)
	NEXT i
		FOR i = 0 TO 179
		Sx(i) = dlU * SG(i)
		Sy(i) = dlU * CG(i)
		PSET ((A * CG(i) * 2500 + 320), (A * SG(i) * 1000 + 100))
		PSET ((A * CG(i) * 2500 + 320), (-A * SG(i) * 1000 + 100))
		NEXT i
FOR t = 0 TO 200
LOCATE 2, 73
PRINT t
	PGx = 0
	PGy = 0
	PGz = 0
	FOR g = 0 TO 179
	Rx = Xv - A * CG(g)
	Rx2 = Rx ^ 2
	   Ux = Sx(g)
		PXx = 0
		PXy = 0
		PXz = 0
		Pqx = 0
		Pqy = 0
		Pqz = 0
		FOR i = 0 TO 359
		Uy = Sy(g) * SG(i)
		Uz = Sy(g) * CG(i)
		Ry = Yv - A * SG(g) * SG(i)
		Rz = Zv - A * SG(g) * CG(i)
		R3 = SQR(Rx2 + Ry * Ry + Rz * Rz) ^ 3
		Hx = K * Iu * (Uy * Rz - Ry * Uz) / R3
		Hy = K * Iu * (Uz * Rx - Rz * Ux) / R3
		Hz = K * Iu * (Ux * Ry - Rx * Uy) / R3
					'Px = Vy*Hz-Hy*Vz    PXx = PXx + Px
					'Py = Vz*Hx-Hz*Vx    PXy = PXy + Py
					'Pz = Vx*Hy-Hx*Vy    PXz = PXz + Pz
		PXx = PXx + Q * (Vy * Hz - Hy * Vz)
		PXy = PXy + Q * (Vz * Hx - Hz * Vx)
		PXz = PXz + Q * (Vx * Hy - Hx * Vy)
			Hqx = K * Q * (-Vy * Rz + Ry * Vz) / R3
			Hqy = K * Q * (-Vz * Rx + Rz * Vx) / R3
			Hqz = K * Q * (-Vx * Ry + Rx * Vy) / R3
			 Pqx = Pqx + Iu * (Uy * Hqz - Hqy * Uz)
			 Pqy = Pqy + Iu * (Uz * Hqx - Hqz * Ux)
			 Pqz = Pqz + Iu * (Ux * Hqy - Hqx * Uy)
			NEXT i
		PGx = PGx + PXx - Pqx
		PGy = PGy + PXy - Pqy
		PGz = PGz + PXz - Pqz
'LOCATE 1, 1
'PRINT USING C$; PGx; PXx; Pqx
		NEXT g
	dVx = PGx * dt / M
	dVy = PGy * dt / M
	dVz = PGz * dt / M
	  Vx = Vx + dVx
	  Vy = Vy + dVy
	  Vz = Vz + dVz
	  V = SQR(Vx ^ 2 + Vy ^ 2 + Vz ^ 2)
	  LOCATE 4, 60
	  PRINT "V'="; USING C$; V
	dXv = Vx * dt
	dYv = Vy * dt
	dZv = Vz * dt
	  Xv = Xv + dXv
	  Yv = Yv + dYv
	  Zv = Zv + dZv
	  PSET (Xv * 2500 + 320, Yv * 1000 + 100)
	LOCATE 2, 1
	PRINT "PG = "; USING C$; PGx; PGy; PGz
	LOCATE 3, 1
	PRINT "dV = "; USING C$; dVx; dVy; dVz
	LOCATE 4, 1
	PRINT "Vx = "; USING C$; Vx; Vy; Vz
	NEXT t
	 END

