SCREEN 2
C$ = "  +#.###^^^^"
Pi = 3.141593
mo = 4 * Pi * .0000001
K = mo / (4 * Pi)
g = 9.8
J1 = 20000000
LOCATE 2, 1
PRINT "J (A/m^2) = "; J1

NI = 45
L = .25
dL = .001
DL1 = .006
DL2 = .01
NL = L / dL
S = Pi * (DL2 ^ 2 - DL1 ^ 2) / 4
IL = S * J1
SIK = IL * NI * 2

LOCATE 2, 25
PRINT "I (A) = "; IL
LOCATE 6, 25
PRINT "I kl (A) = "; SIK

REM ro = .0000016     ' ohm * cm^2 / cm
ro = .000000016#      ' ohm * m        (0.017 om*mm^2/m)
R = ro * (1 * 2.5) / S
P = IL ^ 2 * R
LOCATE 3, 25
PRINT "P (W) = "; P
LOCATE 4, 25
PRINT "R (Ohm) = "; R
Pkl = P * NI * 2
LOCATE 8, 25
PRINT "P kl (W) = "; Pkl
Ukl = Pkl / IL
LOCATE 7, 25
PRINT "U kl (V) = "; Ukl


IK = IL * NI
DK1 = NI * DL2 * 1.02 / Pi
DK2 = 3.5 * DK1
LOCATE 2, 55
PRINT "D kl = "; DK1

    Ux = dL
    Uy = 0
    Uz = 0
    Ry = .075   '(DK2 - DK1) / 2
    Rz = 0
  
     P2y = 0
     FOR J = 0 TO NL - 1
     X1 = J * dL + dL / 2
       
        P1y = 0
        FOR i = 0 TO NL - 1
        X2 = i * dL + dL / 2
        Rx = X2 - X1
                
                R = SQR(Rx * Rx + Ry * Ry + Rz * Rz)

                REM Hx =  (Uy * Rz - Ry * Uz) / R ^ 3
                REM Hy =  (Uz * Rx - Rz * Ux) / R ^ 3
                REM Hz =  (Ux * Ry - Rx * Uy) / R ^ 3
               
                Hz = (Ux * Ry) / R ^ 3

                REM Px =  (Vy * (Hz1 + Hz2) - (Hy1 + Hy2) * Vz)
                REM Py =  (Vz * (Hx1 + Hx2) - (Hz1 + Hz2) * Vx)
                REM Pz =  (Vx * (Hy1 + Hy2) - (Hx1 + Hx2) * Vy)
               
                Py = -Hz * Ux
                P1y = P1y + Py
         
REM          LOCATE 3, 50
REM          PRINT "P1 (kg) = "; USING C$; P1y
           
           
            NEXT i
                P2y = P2y + P1y
           
            NEXT J
                F = K * IL * SIK * P2y / g
                Fil = K * IL * IL * P2y / g
          LOCATE 4, 55
          PRINT "F (kg) = "; USING C$; F
          LOCATE 5, 55
          PRINT "F il (kg) = "; USING C$; Fil



