SCREEN 12
TIMER ON
COLOR 3
LOCATE 3, 17
PRINT " Motion of one deuteron in a magnetic field "
LOCATE 5, 17
PRINT "         such as a Magnetic Cocoon "
LOCATE 7, 17
PRINT "             Ed = 500 eV"
COLOR 15
ON TIMER(3) GOSUB 1
DO WHILE INKEY$ = "": LOOP

1
CLS
DIM X1(80), X2(80)
C$ = "  +#.#####^^^^"
Pi = 3.141593
Mo = 4 * Pi * .0000001
M = 1.67E-27 * 2
Q = 1.6E-19
E = 500        '[eV]
2  CLS
LOCATE 2, 10
INPUT "ANGLE (50 - 175)="; AN
IF 175 < AN GOTO 2
IF AN < 50 GOTO 2
TV = AN * Pi / 180
        V = SQR(2 * E * ABS(Q) / M)
        Vx = V * COS(TV)
        Vy = V * SIN(TV)
        Vz = 0
        LOCATE 2, 60
        PRINT "V ="; USING C$; V
dlq = .0002
'dt = dlq / V
A = .04
YL1 = 0
YL2 = 0
Xv = 0
Yv = .001
Zv = 0
L = .08
DL = .001
N = L / DL
IL = 3000000
K = Mo / (4 * Pi)
        FOR I = 0 TO N - 1
        X1(I) = -I * DL - DL / 2 - A
        X2(I) = I * DL + DL / 2 + A
        NEXT I
FOR t = 0 TO 5000
dt = dlq / V
        PXx = 0
        PXy = 0
        PXz = 0
        FOR I = 0 TO N - 1
        Rx1 = Xv - X1(I)
        Rx2 = Xv - X2(I)
                Ux = DL
                Uy = 0
                Uz = 0
                Ry1 = Yv + YL1
                Ry2 = Yv + YL2
                Rz = Zv
                 R1 = SQR(Rx1 * Rx1 + Ry1 * Ry1 + Rz * Rz)
                 R2 = SQR(Rx2 * Rx2 + Ry2 * Ry2 + Rz * Rz)

                Hy1 = (-Rz * Ux) / R1 ^ 3
                Hz1 = (Ux * Ry1) / R1 ^ 3

                 Hy2 = (-Rz * Ux) / R2 ^ 3
                 Hz2 = (Ux * Ry2) / R2 ^ 3

                Px = (Vy * (Hz1 + Hz2) - (Hy1 + Hy2) * Vz)
                Py = -(Hz1 + Hz2) * Vx
                Pz = Vx * (Hy1 + Hy2)

                 PXx = PXx + Px
                 PXy = PXy + Py
                 PXz = PXz + Pz
            NEXT I
        dVx = Q * K * IL * PXx * dt / M
        dVy = Q * K * IL * PXy * dt / M
        dVz = Q * K * IL * PXz * dt / M
          Vxt = Vx + dVx
          Vyt = Vy + dVy
          Vzt = Vz + dVz
          Vt = SQR(Vxt ^ 2 + Vyt ^ 2 + Vzt ^ 2)
          kV = V / Vt
'kV - the particle must have a constant value modulo of velocity
        Vx = Vxt * kV
        Vy = Vyt * kV
        Vz = Vzt * kV
        V = SQR(Vx ^ 2 + Vy ^ 2 + Vz ^ 2)
        dXv = Vx * dt
        dYv = Vy * dt
        dZv = Vz * dt
          Xv = Xv + dXv
          Yv = Yv + dYv
          Zv = Zv + dZv
     PSET (Xv * 10000 + 320, Yv * 10000 + 240), 12
     NEXT t
END



