SCREEN 12
COLOR 3
 LOCATE 5, 5
 PRINT "       Motion of an electron in a magnetic field "
 LOCATE 7, 5
 PRINT "         such as a Magnetic Cocoon (undulator) "
COLOR 15
C$ = "  +#.#####^^^^"
Pi = 3.14159265359#
M = 9.1E-31
Q = 1.6E-19
jc = 6E+08
dt = 3E-10
Uq = 400!
Du = .001
TV = 30 * Pi / 180
K = 4 * Pi * .0000001 * (-Q) * (jc * Du ^ 2 / 4) / (4 * Pi)
    V = SQR(2 * Q * Uq / M)
    Vx = V * COS(TV)
    Vy = V * SIN(TV)
    Vz = 0
    LOCATE 3, 60
    PRINT "V= "; USING C$; V
A = .03
X1 = -.05
X2 = .05
dX = (X2 - X1) / 100
dG = Pi / 50
Xv = -.32
Yv = 0
Zv = 0
PSET (Xv * 1200 + 420, Yv * 4000 + 300)
    DIM X(100)
    FOR i = 0 TO 99
    X(i) = X1 + i * dX + dX / 2
    PSET (X(i) * 1200 + 420, A * 4000 + 300)
    PSET (X(i) * 1200 + 420, -A * 4000 + 300)
    NEXT i
            PGx = 0
            PGy = 0
            PGz = 0
        FOR t = 1 TO 100
            FOR j = 0 TO 99
            CG = COS(j * dG)
            SG = SIN(j * dG)
                    PXx = 0
                    PXy = 0
                    PXz = 0
                    Ry = -A * CG + Yv
                    Rz = -A * SG + Zv
                    Ry2 = Ry * Ry
                    Rz2 = Rz * Rz
                    Ux = dX                 'Uy = 0    Uz = 0
                    FOR i = 0 TO 99
                    Rx = -X(i) + Xv         'R = SQR(Rx * Rx + Ry2 + Rz2)
                    R3 = (SQR(Rx * Rx + Ry2 + Rz2)) ^ 3
                    Hx = (Vy * Rz - Vz * Ry) / R3
                    Hy = (Vz * Rx - Vx * Rz) / R3
                    Hz = (Vx * Ry - Vy * Rx) / R3
                                             'Px = Uy * Hz - Uz * Hy
                    Py = -Ux * Hz            'Py = Uz * Hx - Ux * Hz
                    Pz = Ux * Hy             'Pz = Ux * Hy - Uy * Hx
                                             'PXx = PXx + Px
                    PXy = PXy - Py
                    PXz = PXz - Pz
                    NEXT i
            'PGx = PGx + PXx
            PGy = PGy + PXy
            PGz = PGz + PXz
            NEXT j
'dVx = K * PGx * dt / M
dVy = K * PGy * dt / M
dVz = K * PGz * dt / M
          Vxt = Vx + dVx
          Vyt = Vy + dVy
          Vzt = Vz + dVz
          Vt = SQR(Vxt ^ 2 + Vyt ^ 2 + Vzt ^ 2)
          kV = V / Vt
'kV - the particle must have a constant value modulo of velocity
        Vx = Vxt * kV
        Vy = Vyt * kV
        Vz = Vzt * kV
        V = SQR(Vx ^ 2 + Vy ^ 2 + Vz ^ 2)
dXv = Vx * dt
dYv = Vy * dt
dZv = Vz * dt
  Xv = Xv + dXv
  Yv = Yv + dYv
  Zv = Zv + dZv
  PSET (Xv * 1200 + 420, Yv * 4000 + 300), 12
NEXT t

